using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class LampDriver : MonoBehaviour
{

    [SerializeField] private SpriteRenderer spriteRenderer;
    [SerializeField] private PlayerController playerController;
    [SerializeField] private float switchDelay;
    [SerializeField] private float cycleOffset;
    private float timeToNextSwitch;

    private System.Random _random;
    
    // Start is called before the first frame update
    void Start()
    {
        _random = new System.Random();
        timeToNextSwitch = switchDelay + cycleOffset;
        if (0 == cycleOffset)
        {
            cycleOffset = (float) _random.NextDouble();
            switchDelay = (float)_random.NextDouble();
        }
    }

    // Update is called once per frame
    void Update()
    {

        if (playerController.fancyDance)
        {
            return;
        }
        
        timeToNextSwitch -= switchDelay * Time.deltaTime;
        if (0 > timeToNextSwitch)
        {
            spriteRenderer.color = new Color32((byte) _random.Next(255), (byte) _random.Next(255), (byte) _random.Next(255), 255);
            timeToNextSwitch = switchDelay;
        } 
    }
}
