using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class NpcController : MonoBehaviour
{

    private float _startDelay = 5;
    private float _delayProgess = 0;
    
    //Dance Crap------------------------------------------------------
    private List<Dance> _dances;
    
    private bool _dancing;
    private int _currentDance;
    private int _currentMove;
    private bool _danceValsSet;

    
    //Location
    private Vector3 _step;
    private Vector3 _target;
    private bool _locationTargetReached;
    
    //Rotation
    private float _rotationTarget;
    private float _rotationStep;
    private bool _rotationTargetReached;
    
    //Scale
    private float _scaleTarget;
    private float _scaleStep;
    private bool _scaleTargetReached;
    
    //Dance Crap------------------------------------------------------

    private System.Random _random;


    // Start is called before the first frame update
    void Start()
    {

        _random = new System.Random();
        
        _dances = new List<Dance>();
        
        _dances.Add(
            new Dance(
                    new Dance.Move(0.7f, new Vector3(1, 2), 0.7f, 4),
                    new Dance.Move(0.7f, new Vector3(-1, -2), -0.7f, -4)
            )
        );

        _dances.Add(
            new Dance(
                new Dance.Move(0.4f, new Vector3(4, 0), 0, 5),
                new Dance.Move(0.4f, new Vector3(-4, 0), 0, -5)
            )
        );
        
        _dances.Add(
            new Dance(
                new Dance.Move(0.9f, new Vector3(0, 0), 0, 2),
                new Dance.Move(0.9f, new Vector3(0, 0), 0, -2),
                new Dance.Move(0.9f, new Vector3(0, 0), 0, 2),
                new Dance.Move(0.9f, new Vector3(0, 0), 0, -2),
                new Dance.Move(0.9f, new Vector3(0, 0), 0, 2),
                new Dance.Move(0.9f, new Vector3(0, 0), 0, -2)
            )
        );
        
        _dances.Add(
            new Dance(
                new Dance.Move(0.7f, new Vector3(1,1), 0, 0),
                new Dance.Move(0.7f, new Vector3(1,1), 0, 0),
                new Dance.Move(0.7f, new Vector3(-1,-1), 0, 0),
                new Dance.Move(0.7f, new Vector3(-1,-1), 0, 0)
            )
        );
    }

    // Update is called once per frame
    void Update()
    {

        if (_delayProgess < _startDelay)
        {
            _delayProgess += Time.deltaTime * 1;
            return;
        }
        
        if (_dancing)
        {
            var dance = _dances[_currentDance];
            var move = dance.DanceMoves[_currentMove];

            if (!_danceValsSet)
            {
                _step = move.Position / move.DelayToPrevious;
                _target = new Vector3(transform.position.x + move.Position.x, transform.position.y + move.Position.y, 1);

                _rotationStep = move.Rotation / move.DelayToPrevious;
                _rotationTarget = transform.rotation.z + move.Rotation;

                _scaleStep = move.Scale / move.DelayToPrevious;
                _scaleTarget = transform.localScale.x + move.Scale;
                
                _danceValsSet = true;
            }

            //Position--------------------------------------------------
            if (!_locationTargetReached)
            {
                transform.position += Time.deltaTime * _step;   
            }

            if (Vector3.Distance(transform.position, _target) <= 0.5)
            {
                _locationTargetReached = true;
            }
            
            //Rotation------------------------------------------------
            if (!_rotationTargetReached)
            {
                var newZ = transform.rotation.z + Time.deltaTime * _rotationStep;
                transform.rotation = new Quaternion(transform.rotation.x, transform.rotation.y, newZ, transform.rotation.w).normalized;
            }
            
            if (Math.Abs(transform.rotation.z - _rotationTarget) <= 0.5)
            {
                _rotationTargetReached = true;
            }
            
            //Scale--------------------------------------------------
            if (!_scaleTargetReached)
            {
                var newScale = transform.localScale.x + Time.deltaTime * _scaleStep;
                transform.localScale = new Vector3(newScale, newScale);
            }
            
            if (Math.Abs(transform.localScale.x - _scaleTarget) <= 0.5)
            {
                _scaleTargetReached = true;
            }
            
            if (_locationTargetReached && _rotationTargetReached && _scaleTargetReached)
            {
                _locationTargetReached = false;
                _rotationTargetReached = false;
                _scaleTargetReached = false;
                _danceValsSet = false;
                if (dance.DanceMoves.Length > _currentMove + 1)
                {
                    _currentMove += 1;
                }
                else
                {
                    _dancing = false;
                    transform.rotation = new Quaternion(transform.rotation.x, transform.rotation.y, 0, transform.rotation.w).normalized;
                    transform.localScale = new Vector3(1, 1, 1);
                }
            }
            return;
        }

        if (_random.Next(101) < 1)
        {
            var randomNumber = _random.Next(_dances.Count);
            
            Debug.Log(randomNumber);
        
            _dancing = true;
            _currentDance = randomNumber;
            _currentMove = 0;
        }
    }
}
