using System;
using System.Collections;
using System.Collections.Generic;
using System.Threading;
using UnityEngine;

public class PlayerController : MonoBehaviour
{
    [SerializeField] private float playerMovementSpeed = 5f;
    [SerializeField] private BackgroundController backgroundController;
    
    public bool fancyDance { get; set; }

    //Dance Crap------------------------------------------------------
    private Vector3 _currentPosition;
    private List<Dance> _dances;
    
    private bool _dancing;
    private int _currentDance;
    private int _currentMove;
    private bool _danceValsSet;

    
    //Location
    private Vector3 _step;
    private Vector3 _target;
    private bool _locationTargetReached;
    
    //Rotation
    private float _rotationTarget;
    private float _rotationStep;
    private bool _rotationTargetReached;
    
    //Scale
    private float _scaleTarget;
    private float _scaleStep;
    private bool _scaleTargetReached;
    
    //Dance Crap------------------------------------------------------
    

    // Start is called before the first frame update
    void Start()
    {
        _dances = new List<Dance>();
        
        _dances.Add(
            new Dance(
                    new Dance.Move(0.7f, new Vector3(1, 2), 0.7f, 13),
                    new Dance.Move(0.7f, new Vector3(-1, -2), -0.7f, -13)
            )
        );
        
        // Sena
        _dances.Add(
            new Dance(
                new Dance.Move(0.4f, new Vector3(1, 0), 0.25f, 0),
                new Dance.Move(0.8f, new Vector3(0, 2), 0, 0),
                new Dance.Move(0.8f, new Vector3(-2, 0), 0, 0),
                new Dance.Move(0.8f, new Vector3(0, -2), 0, 0), 
                new Dance.Move(0.4f, new Vector3(1, 0), -0.25f, 0)
            )
        );
        _dances.Add(
            new Dance(
                new Dance.Move(0.2f, new Vector3(0, 0), 0.5f, 0),
                new Dance.Move(0.2f, new Vector3(0, 0), -1f, 0),
                new Dance.Move(0.2f, new Vector3(0, 0), 1f, 0),
                new Dance.Move(0.2f, new Vector3(0, 0), -1f, 0),
                new Dance.Move(0.2f, new Vector3(0, 0), 1f, 0),
                new Dance.Move(0.2f, new Vector3(0, 0), -0.5f, 0)
            )
        );
        _dances.Add(
            new Dance(
                new Dance.Move(0.8f, new Vector3(2, 0), 0, 2),
                new Dance.Move(0.8f, new Vector3(0, 2), 0.2f, 2),
                new Dance.Move(0.8f, new Vector3(2, 0), -0.2f, -4),
                new Dance.Move(0.8f, new Vector3(-2, -2), 0, 5),
                //new Dance.Move(0.4f, new Vector3(0, 0), 0, 1),
                //new Dance.Move(0.8f, new Vector3(-4, 0), 0, -3),
                new Dance.Move(0.8f, new Vector3(-2, 2), 0, -3),
                new Dance.Move(0.8f, new Vector3(0, -2), 0.8f, 1),
                new Dance.Move(0.8f, new Vector3(-2, 2), -0.8f, -3)
            )
        );
        
        _dances.Add(
            new Dance(
                new Dance.Move(0.4f, new Vector3(-2, 0), 0, 0), 
                new Dance.Move(0.6f, new Vector3(4, 0), 0, 0),
                new Dance.Move(0.6f, new Vector3(-2, 2), 0, 0),
                new Dance.Move(0.6f, new Vector3(-2, -2), 0, 0),
                new Dance.Move(0.6f, new Vector3(2, -2), 0, 0),
                new Dance.Move(0.6f, new Vector3(2, 2), 0, 0),
                new Dance.Move(0.6f, new Vector3(-2, 0), 0, 0),
                new Dance.Move(0.4f, new Vector3(0, 0), 0.25f, 0),
                new Dance.Move(0.4f, new Vector3(0, 0), 0, 4),
                new Dance.Move(0.4f, new Vector3(0, 0), 0.25f, 0),
                new Dance.Move(0.4f, new Vector3(0, 0), 0, 4),
                new Dance.Move(0.4f, new Vector3(0, 0), -0.25f, 0),
                new Dance.Move(0.4f, new Vector3(0, 0), 0, 4),
                new Dance.Move(0.4f, new Vector3(0, 0), -0.25f, 0),
                new Dance.Move(0.4f, new Vector3(0, 0), 0, -20),
                new Dance.Move(0.2f, new Vector3(0, 0), 0, 8),
                new Dance.Move(0.2f, new Vector3(0, 0), -0.25f, 0),
                new Dance.Move(0.2f, new Vector3(0, 0), 0.50f, 0),
                new Dance.Move(0.2f, new Vector3(0, 0), -0.50f, 0),
                new Dance.Move(0.2f, new Vector3(0, 0), 0.25f, 0)
            )    
        );
        _dances.Add(
            new Dance(
                new Dance.Move(0.3f, new Vector3(0, 2), 0.3f, 0),
                new Dance.Move(0.3f, new Vector3(0, -2), -0.3f, 0),
                new Dance.Move(0.3f, new Vector3(0, 2), -0.3f, 0),
                new Dance.Move(0.3f, new Vector3(0, -2), 0.3f, 0),
                new Dance.Move(0.4f, new Vector3(3, 0), -0.8f, 0),
                new Dance.Move(0.4f, new Vector3(-3, 0), 0.8f, 0),
                new Dance.Move(0.4f, new Vector3(-3,0), 0.8f, 0),
                new Dance.Move(0.4f, new Vector3(3, 0), -0.8f, 0),
                new Dance.Move(0.2f, new Vector3(0, 0), 0f, 5),
                new Dance.Move(0.2f, new Vector3(0, 0), 0f, -5),
                new Dance.Move(0.2f, new Vector3(0, 10), 0f, 0),
                new Dance.Move(0.8f, new Vector3(0, -10), 0f, 0)
            )
        );
    }

    // Update is called once per frame
    void Update()
    {
        if (_dancing)
        {
            var dance = _dances[_currentDance];
            var move = dance.DanceMoves[_currentMove];

            if (!_danceValsSet)
            {
                _step = move.Position / move.DelayToPrevious;
                _target = new Vector3(transform.position.x + move.Position.x, transform.position.y + move.Position.y, 1);

                _rotationStep = move.Rotation / move.DelayToPrevious;
                _rotationTarget = transform.rotation.z + move.Rotation;

                _scaleStep = move.Scale / move.DelayToPrevious;
                _scaleTarget = transform.localScale.x + move.Scale;
                
                _danceValsSet = true;
            }

            //Position--------------------------------------------------
            if (!_locationTargetReached)
            {
                transform.position += Time.deltaTime * _step;   
            }

            if (Vector3.Distance(transform.position, _target) <= 0.2)
            {
                _locationTargetReached = true;
            }
            
            //Rotation------------------------------------------------
            if (!_rotationTargetReached)
            {
                var newZ = transform.rotation.z + Time.deltaTime * _rotationStep;
                transform.rotation = new Quaternion(transform.rotation.x, transform.rotation.y, newZ, transform.rotation.w).normalized;
            }
            
            if (Math.Abs(transform.rotation.z - _rotationTarget) <= 0.01)
            {
                _rotationTargetReached = true;
            }
            
            //Scale--------------------------------------------------
            if (!_scaleTargetReached)
            {
                var newScale = transform.localScale.x + Time.deltaTime * _scaleStep;
                transform.localScale = new Vector3(newScale, newScale);
            }
            
            if (Math.Abs(transform.localScale.x - _scaleTarget) <= 0.1 )
            {
                _scaleTargetReached = true;
            }
            
            if (_locationTargetReached && _rotationTargetReached && _scaleTargetReached)
            {
                _locationTargetReached = false;
                _rotationTargetReached = false;
                _scaleTargetReached = false;
                _danceValsSet = false;
                if (dance.DanceMoves.Length > _currentMove + 1)
                {
                    _currentMove += 1;
                }
                else
                {
                    _dancing = false;
                    transform.rotation = new Quaternion(transform.rotation.x, transform.rotation.y, 0, transform.rotation.w).normalized;
                    transform.localScale = new Vector3(1, 1, 1);
                    if (fancyDance)
                    {
                        fancyDance = false;
                        backgroundController.OpenLights();
                    }
                }
            }

            return;
        }

        if (Input.GetKeyDown(KeyCode.Alpha1))
        {
            _dancing = true;
            _currentDance = 0;
            _currentMove = 0;
        }
        // alpha2
        if (Input.GetKeyDown(KeyCode.Alpha2))
        {
            _dancing = true;
            _currentDance = 1;
            _currentMove = 0;
        }
        // alpha3
        if (Input.GetKeyDown(KeyCode.Alpha3))
        {
            _dancing = true;
            _currentDance = 2;
            _currentMove = 0;
        }
        
        // alpha4
        if (Input.GetKeyDown(KeyCode.Alpha4))
        {
            _dancing = true;
            _currentDance = 3;
            _currentMove = 0;
            fancyDance = true;
            backgroundController.DimLights();
        }
        // alpha6
        if (Input.GetKeyDown(KeyCode.Alpha6))
        {
            _dancing = true;
            _currentDance = 5;
            _currentMove = 0;
            fancyDance = true;
            backgroundController.DimLights();
        }
        
        if (Input.GetKeyDown(KeyCode.Alpha5))
        {
            _dancing = true;
            _currentDance = 4;
            _currentMove = 0;
            fancyDance = true;
            backgroundController.DimLights();
        }

        Vector3 velocityVector = Vector3.zero;

        if (Input.GetKey(KeyCode.W)) velocityVector.y = 1;
        if (Input.GetKey(KeyCode.A)) velocityVector.x = -1;
        if (Input.GetKey(KeyCode.S)) velocityVector.y = -1;
        if (Input.GetKey(KeyCode.D)) velocityVector.x = 1;
        
        velocityVector.Normalize();
        
        transform.position += Time.deltaTime * playerMovementSpeed * velocityVector;
        _currentPosition = transform.position;
    }

    public Vector3 GetPlayerPosition()
    {
        return _currentPosition;
    }
}
